/*Copyright (C) 2009  Annette Bieniusa, Thomas Fuhrmann.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dstm;

/**
 * Message sent by GAO showing whether a GAOV has been chosen by the GAO or not.
 * @author Annette Bieniusa
 */

public class VoteMessage<T> extends GaoMessage<T> {
	public static enum Vote {
		POS, NEG, FAILED;
	}
	
	private Vote vote;
	
	protected VoteMessage (GAO<T> sender, Transaction receiver, Vote vote) {
		super(sender, receiver, GaoMessage.Type.VOTE);
		assert(sender != null);
		this.vote = vote;
	}
	
	@Override
	public String toString() {
		return (getSender() +" votes "+ vote);
	}
	
	protected Vote getVote() {
		return vote;
	}
	
}
